/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */  
import javax.swing.DefaultListModel;
import java.awt.BorderLayout;
import java.util.StringTokenizer;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import java.awt.Toolkit;
import java.awt.Font;
import javax.swing.ImageIcon;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.ListSelectionModel;
import javax.swing.JProgressBar;
import javax.swing.BorderFactory;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Vector;
import java.awt.Dimension;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import java.awt.Rectangle;
public class Nodeprogramming extends JPanel{ 
	private JList jList = null;
	private JButton addButton = null;
	private JButton jButton = null;
	private JButton Button1 = null;
	private JPanel jPanel = null;
	private JTextField jTextField = null;
	private JButton jButton1 = null;
	private JButton jButton2 = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel2 = null;
	
	private JList jList3 = null;
	static DefaultListModel listModel = new DefaultListModel();// list Model of the selected mote
	//********************************************// file
	ExeFilter fIhexFilter = new ExeFilter ();
	File fFile = new File ("main.ihex");
	Vector sensor= new Vector();
	private JScrollPane jScrollPane = null;
	private JScrollPane jScrollPane1 = null;
	private JButton jButton3 = null;
	JDialog dialog;
          			
      class thread1 implements Runnable{
      		public void run() {
              		waintingpanel pnl = new waintingpanel(); 
              		dialog = new JDialog((JFrame)null, "Working ...");
					dialog.getContentPane().add(pnl, null);
					pnl.setBounds(new java.awt.Rectangle(10,10,100,50));
					dialog.setLocationRelativeTo(null);
					dialog.pack();
					dialog.setVisible(true);
					dialog.setAlwaysOnTop(true);
					
            		}
      }
      class thread2 implements Runnable{
      	        install installer = new install();
				public void run() {
				for (int i=0;i<listModel.size();i++)
					{
				     StringTokenizer st = new StringTokenizer(listModel.getElementAt(i).toString());
				     st.hasMoreTokens();
				     st.nextToken(",");
				     st.hasMoreTokens();
				     String tk =st.nextToken(",");
				     int nodeid=Integer.parseInt(tk.charAt((tk.length()-1))+"");
				     st.hasMoreTokens();
				     st.nextToken(",");
				     st.hasMoreTokens();
				     tk= st.nextToken(",");
				     String comport=tk;
				     System.out.println(nodeid+","+comport);		     
					 installer.nodeprogram(nodeid,comport);
					 System.out.print("Done!!!");
					}
				dialog.pack();
				dialog.setVisible(false);
				dialog.dispose();
				}
      }

	public Nodeprogramming() {
		super();
		initialize();
	}
	public static DefaultListModel getListM()
	{return listModel;}

	private void initialize() {
        this.setSize(new java.awt.Dimension(1240,195));
        this.setLayout(null);
        this.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Nodes reprogramming", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
        this.setBackground(java.awt.SystemColor.control);
        this.setFont(new java.awt.Font("Arial",0,12));
        this.setPreferredSize(new java.awt.Dimension(1267, 195));
        this.add(getJPanel1(), null);
        this.add(getJPanel2(), null);
        this.add(getAddButton(), null);
        this.add(getJButton(), null);
        this.add(getButton1(), null);
        this.add(getJPanel(), null);
        this.add(getJButton3(), null);
		try{ 
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
		}catch(Exception e){
			e.printStackTrace();	
		} 
		SwingUtilities.updateComponentTreeUI(this);		
	}
	
	private void load_connected_mote()
	{
		
	   NodeInfoCollection collection =  new NodeInfoCollection();
	   collection.initiate();
	   NodeInfoListModel listModel1 =  new NodeInfoListModel(collection);
	   getJList3().setModel(listModel1);
	   getJScrollPane().repaint();
	   listModel.removeAllElements();
	   if (listModel1.getSize()==0)
	   { Toolkit.getDefaultToolkit().beep();
		   JOptionPane.showMessageDialog(null,"        No Motes Found!!","Warning",JOptionPane.ERROR_MESSAGE);}
   
	}
	boolean searching(DefaultListModel mdl, Object obj)
	{
		boolean notfind=true;
		int i=0;
		while(notfind && (i<mdl.size()))
			{
			System.out.println("mdl"+mdl.elementAt(i));
			System.out.println("obj"+obj.toString());
			notfind=(!mdl.elementAt(i).equals(obj));
			System.out.println("notified"+notfind);
			i++;
			
			}
		return notfind;
	}
	private boolean open(File fFile)
	{
	    JFileChooser fc = new JFileChooser ();
	    fc.setDialogTitle ("Open File");

	    // Choose only files, not directories
	    fc.setFileSelectionMode ( JFileChooser.FILES_ONLY);

	    // Start in current directory
	    fc.setCurrentDirectory (new File ("."));

	    // Set filter for Java source files.
	    fc.setFileFilter (fIhexFilter);

	    // Now open chooser
	    int result = fc.showOpenDialog (this);

	    if (result == JFileChooser.CANCEL_OPTION) {
	        return true;
	    } else if (result == JFileChooser.APPROVE_OPTION) {

	        fFile = fc.getSelectedFile ();
	        // Invoke the readFile method in this class
	        //String file_string = readFile (fFile);

	        if (fFile != null)
	        {
	        	jTextField.setText(fFile.getAbsolutePath());
	        	save(fFile.getAbsolutePath().toString());//********************************
	       
	        }else
	            return false;
	    } else {
	        return false;
	    }
	    return true;
	 }
		
	private boolean save(String File_string)
	{
		File folder = new File("sourcecode\\tempo");
		if(!folder.exists()) {
			folder.mkdirs();
		}
		FileCopy fl = new FileCopy();
		try { fl.copy(File_string,folder.getAbsolutePath().toString()); 
		return true;	}
	    catch (IOException e) { System.err.println(e.getMessage()); 
	    return false;}
		

	       // return true;	
	}
	public static boolean writeFile (File file, String dataString) {
	    try {
	       PrintWriter out =
	         new PrintWriter (new BufferedWriter (new FileWriter (file)));
	       out.print (dataString);
	       out.flush ();
	       out.close ();
	    }
	    catch (IOException e) {
	       return false;
	    }
	    return true;
	  } // writeFile
	public String readFile (File file) {

	    StringBuffer fileBuffer;
	    String fileString=null;
	    String line;

	    try {
	      FileReader in = new FileReader (file);
	      BufferedReader dis = new BufferedReader (in);
	      fileBuffer = new StringBuffer () ;

	      while ((line = dis.readLine ()) != null) {
	            fileBuffer.append (line + "\n");
	      }

	      in.close ();
	      fileString = fileBuffer.toString ();
	    }
	    catch  (IOException e ) {
	      return null;
	    }
	    return fileString;
	  }
	//============================================================

	/**
	 * This method initializes jList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJList() {
		if (jList == null) {
			jList = new JList(listModel);
			jList.setLayoutOrientation(JList.VERTICAL);
			jList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			jList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
				public void valueChanged(javax.swing.event.ListSelectionEvent e) {
					System.out.println("valueChanged()"); // TODO Auto-generated Event stub valueChanged()
					if (listModel.size()>0)
						getJButton2().setEnabled(true);
				}
			});
	        //jList.setBounds(new java.awt.Rectangle(431,73,303,170));
			jList.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			//jList.setPreferredSize(new Dimension(305, 155));
		}
		return jList;
	}

	/**
	 * This method initializes addButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAddButton() {
		if (addButton == null) {
			addButton = new JButton();
			addButton.setBounds(375, 151, 28, 28);
			addButton.setIcon(new ImageIcon(getClass().getResource("images/left--.png")));
			addButton.setToolTipText("Remove");
			addButton.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
			addButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					Object[] tab =getJList().getSelectedValues();
					for (int o =0;o<tab.length;o++){
						listModel.removeElement(tab[o]);					
					}
					
				}
			});
		}
		return addButton;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(375, 111, 28, 28);
			jButton.setText("");
			jButton.setIcon(new ImageIcon(getClass().getResource("images/--right.png")));
			jButton.setToolTipText("Add");
			jButton.setFont(new Font("Dialog", Font.BOLD, 12));
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"+listModel.size());
					//listModel= getJList3().getModel();
					Object[] tab =getJList3().getSelectedValues();
					for (int o =0;o<tab.length;o++){
						if (searching(listModel,tab[o]))
						listModel.addElement(tab[o]);
						
					}
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes Button1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton1() {
		if (Button1 == null) {
			Button1 = new JButton();
			Button1.setBounds(375, 31, 28, 28);
			Button1.setToolTipText("update the list of pc connected Motes");
			Button1.setIcon(new ImageIcon(getClass().getResource("images/refresh_blue.gif")));
			Button1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					load_connected_mote();
				}
			});
		}
		return Button1;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setBounds(762, 21, 497, 164);
			jPanel.setBackground(java.awt.SystemColor.control);
			jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Install program", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), java.awt.Color.black));
			//jPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(19,186,226),1));
			jPanel.setLayout(null);

			jPanel.add(getJTextField(), null);
			jPanel.add(getJButton1(), null);
			jPanel.add(getJButton2(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setBounds(7, 35, 372, 28);
			jTextField.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
		}
		return jTextField;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setBounds(382, 35, 91, 28);
			jButton1.setText("Browse ...");
			jButton1.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					open(fFile);
					if(listModel.size()>0)
						getJButton2().setEnabled(true);
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setEnabled(false);
			jButton2.setBounds(7, 91, 468, 35);
			jButton2.setText("     Install");
			jButton2.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jButton2.setIcon(new ImageIcon(getClass().getClassLoader().getResource("images/installdisk.png")));
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()

				thread1 t = new thread1();
				thread2 t2 = new thread2();
				new Thread(t).start();
				new Thread(t2).start();

					


					//////////////////////////////////////
	
				
          			
          			
					
					///////////////////////////////////////
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(null);
			jPanel1.add(getJScrollPane1(), null);
			jPanel1.setBounds(413, 21, 329, 165);
			jPanel1.setBackground(java.awt.SystemColor.control);
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Selected nodes", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.PLAIN, 12), java.awt.Color.black));


		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.setLayout(null);
			jPanel2.setBounds(14, 21, 349, 165);
			jPanel2.setBackground(java.awt.SystemColor.control);
			jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Connected nodes", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.PLAIN, 12), java.awt.Color.black));
			jPanel2.setFont(new java.awt.Font("Arial",0,12));
			jPanel2.add(getJScrollPane(), null);

			
		}
		return jPanel2;
	}


	/**
	 * This method initializes jList3	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJList3() {
		if (jList3 == null) {
		    NodeInfoRenderer nodeInfoRenderer = new NodeInfoRenderer();
		    nodeInfoRenderer.setAutoscrolls(true);
		    NodeInfoCollection collection =  new NodeInfoCollection();
		    collection.initiate();
		    NodeInfoListModel listModel =  new NodeInfoListModel(collection);
		    jList3 = new JList(listModel);
			//jList3.setBounds(new java.awt.Rectangle(57,73,305,155));
			jList3.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			//jList3.setPreferredSize(new Dimension(305, 155));
			jList3.setCellRenderer(nodeInfoRenderer);
			jList3.setLayoutOrientation(JList.VERTICAL);
			jList3.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		}
		return jList3;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new java.awt.Rectangle(9,21,329,134));
			jScrollPane.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			jScrollPane.getViewport().add(getJList3());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jScrollPane1	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setBounds(new java.awt.Rectangle(9,21,312,134));
			jScrollPane1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			jScrollPane1.getViewport().add(getJList());
		}
		return jScrollPane1;
	}
	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setBounds(new java.awt.Rectangle(375,71,28,28));
			jButton3.setIcon(new ImageIcon(getClass().getResource("images/selectAll.png")));
			jButton3.setText("");
			jButton3.setToolTipText("Select all");
			jButton3.setFont(new Font("Dialog", Font.BOLD, 12));
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.print(""+getJList3().getModel().getSize());
					int idxtab[]=new int [getJList3().getModel().getSize()];
					for(int j=0;j < getJList3().getModel().getSize();j++)
						idxtab[j]=j;
						getJList3().setSelectedIndices(idxtab);
				}
			});
		}
		return jButton3;
	}


 

}  //  @jve:decl-index=0:visual-constraint="10,10"



