/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 
import java.io.*;
import java.util.StringTokenizer;
import java.util.Vector;
public class motelist{ 
  public static final String MOTELISTCMDL = "/usr/local/bin/motelist -c";
  public static final String MOTELISTCMDW = "c:\\tinyos\\cygwin\\bin\\motelist.exe -c";
  public static final String PLATFORM = "telosb";
    InputStreamReader isr = null;
    BufferedReader br = null;
    Vector motes = new Vector();
    void mlist()
    {
    
    try {
      Process p = null;

      System.out.println(">>OS is " + System.getProperty("os.name"));
      if(System.getProperty("os.name").equals("Linux")) {
    	  try{
        p = Runtime.getRuntime().exec(MOTELISTCMDL);}
    	  catch(Exception exc){}
      } else {
    	  try{
        p = Runtime.getRuntime().exec(MOTELISTCMDW);}
    	  catch(Exception exc){}
      }
try{
      isr = new InputStreamReader(p.getInputStream());
      br = new BufferedReader(isr);
}
catch(Exception excp){}
String line = null;
try{
      while((line = br.readLine()) != null) {
        StringTokenizer parser = new StringTokenizer(line, ",");
        String id = parser.nextToken();
        String port = parser.nextToken().trim();
        motes.addElement(port);
        System.out.println("*** " + id + " - " + port);
      }}catch(Exception expc){}
    } catch(Exception ex) {
      ex.printStackTrace();
    } finally {
      if( br != null) try {  br.close(); } catch(Exception ex) {}
      if(isr != null) try { isr.close(); } catch(Exception ex) {}
    }
    }
  }