/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */
import javax.swing.JOptionPane;
import java.sql.*;
public class DBconnection
{
	boolean isEmpty = true;
	 public DBconnection() {
    }
	// open connection with the specified database
    public void open_a_connection()
    {  
    try
    {
    String driverName = "org.gjt.mm.mysql.Driver";
    Class.forName(driverName);
    String url = "jdbc:mysql://localhost:3306/experiment";// database name
    String username = "root";// connection settings
    String password = "aaaa";// connection settings
    db = DriverManager.getConnection(url, username, password);
    	System.out.println("your installation of JDBC Driver OK.");  	
        }
      catch (Exception e) {
      System.out.println("Failed: JDBC Driver Error: " + e.getMessage());
    }
      try {
          st=db.createStatement();
          st2=db.createStatement();}                             
      catch(SQLException se) {
          se.printStackTrace();
      }
    }
    // close connection with the current database
    public void close_a_connection()
    {
    	try{  
    		db.close();
    		}
    		catch(Exception e){
    		System.out.println("Could not stop connection");
    			}
    }
    // insert data into linkData table
    public void insertLinkdata (int src_id, int seq_no, String experiment_exp_id, String experiment_exp_run_nbr,
            String src_timestamp, int rcv_id, String rcv_timestamp, int lqi, int rssi, int nrssi, double snr, double humidity,
            double temperature, double voltage, double light1 ,double light2, double pressure, float src_x, float src_y, float src_z, float rcv_x, 
            float rcv_y, float rcv_z, int rtx){
        	int nrows=0;
			String ins = "";
        	try {
        		String verifying ="SELECT src_id, rcv_id, exp_id, exp_run_nbr, seq_no FROM linkData WHERE ((src_id='"+src_id+"') AND (rcv_id='"+rcv_id+"') AND (exp_id='"+experiment_exp_id+"') AND (exp_run_nbr='"+experiment_exp_run_nbr+"') AND (seq_no='"+seq_no+"'));";
				Statement sst=db.createStatement();
				ResultSet rs = sst.executeQuery(verifying);
				try{
					if (rs.next())
					isEmpty=false;
				}
			catch(Exception noexp){System.out.println("could not insert data in linkdata table "+noexp.getMessage());}	
            if (isEmpty)
            	{
            	ins="INSERT INTO linkData (src_id, seq_no, exp_id, exp_run_nbr," +
                    " src_timestamp, rcv_id, rcv_timestamp, lqi, rssi, noise, snr, humidity, temperature, voltage," +
                    " light1, light2, pressure, src_x, src_y, src_z, rcv_x, rcv_y, rcv_z, rtxcount) VALUES (" +
                    "'"+src_id+"', " +
                    "'"+seq_no+"', " +
                    "'"+experiment_exp_id+"', " + 
                    "'"+experiment_exp_run_nbr+"', " + 
                    "'"+src_timestamp+"', " + 
                    "'"+rcv_id+"', " + 
                    "'"+rcv_timestamp+"', " +
                    "'"+lqi+"', " + 
                    "'"+rssi+"', " +
                    "'"+nrssi+"', " +
                    "'"+snr+"', " + 
                    "'"+humidity+"', " + 
                    "'"+temperature+"', " +
                    "'"+voltage+"', " +
                    "'"+light1+"', " +
                    "'"+light2+"', " +
		    		"'"+pressure+"', " +  
		    		"'"+src_x+"', " +  
		    		"'"+src_y+"', " +  
                    "'"+src_z+"', " +  
                    "'"+rcv_x+"', " +  
                    "'"+rcv_y+"', " +  
                    "'"+rcv_z+"', " +  
                    "'"+rtx+"');"; 
            		st.execute(ins);
           		 }
        		} catch (SQLException se) {
	    		System.out.println("link data Fail to execute");
           		 se.printStackTrace();
       			 }
   		 }
   	// insert data into experiment table
	public void insertExperiment (int row,String exp_id, String exp_run_nbr, String exp_date, String exp_time, 
        String exp_payload_size, String exp_tx_power, String exp_channel, String exp_topology, 
        String exp_node_type, String exp_country, String exp_city, String exp_description, String exp_nbr_nodes,
        String exp_inter_pkt_time, String exp_nbr_sent_packet, boolean exp_ackonOff, String exp_maxRetNbr, String traffic, String burstwin, String exp_place, String exp_implied_nodes){
    	int nrows=0;
    	try {
        	String ins="INSERT INTO experiment (rownum, exp_id, exp_run_nbr, exp_date, exp_time, exp_payload_size, " +
                "exp_inter_pkt_time, exp_nbr_sent_packet, exp_nbr_nodes, exp_tx_power, exp_channel, " +
                "exp_ack_onoff, exp_max_retries, exp_topology, exp_node_type, exp_country, " +
                "exp_city, exp_traffic, exp_description,exp_place,exp_implied_nodes, exp_burst_window) VALUES (" +
                "'"+row+"', " +
                "'"+exp_id+"', " +
                "'"+exp_run_nbr+"', " +
                "'"+exp_date+"', " + 
                "'"+exp_time+"', " +
                "'"+exp_payload_size+"', " +
                "'"+exp_inter_pkt_time+"', " +
                "'"+exp_nbr_sent_packet+"', " +
                "'"+exp_nbr_nodes+"', " +
                "'"+exp_tx_power+"', " +
                "'"+exp_channel+"', " +
                "'"+exp_ackonOff+"', " +
                "'"+exp_maxRetNbr+"', " +
                "'"+exp_topology+"', " +
                "'"+exp_node_type+"', " +
                "'"+exp_country+"', " +
                "'"+exp_city+"', " +
                "'"+traffic+"', " +
                "'"+exp_description+"', " +
                "'"+exp_place+"', " +
                "'"+exp_implied_nodes+"', " +
                "'"+burstwin+"');";
        	nrows=st.executeUpdate(ins);
    		} catch (SQLException se) {
    		System.out.println("Experiment Fail to execute");
        	se.printStackTrace();
    	}
	}
    // insert data into SenderSide table
    public void insertSender (String id, String runn, String src, String dest,String seqn, String src_time, String rtx, String ackted){
        int nrows=0;
	String ins = "";
        try {
            ins="INSERT INTO SenderSide (src_id,seq_no,exp_id,exp_run_nbr,src_timestamp,rcv_id,rtxcount,ackted) VALUES (" +
                    "'"+src+"', " +
                    "'"+seqn+"', " +
                    "'"+id+"', " +
                    "'"+runn+"', " + 
                    "'"+src_time+"', " +
                    "'"+dest+"', " +
                    "'"+rtx+"', " +
                    "'"+ackted+"');";
            nrows=st.executeUpdate(ins);
        } catch (SQLException se) {
	    System.out.println("Experiment Fail to execute");
	    System.out.println("sql que falhou: " + ins);
            se.printStackTrace();
        }
    }
    // delete table  
    public void delete (String table)
    {
        int nrows=0;
        try {
            String del="DELETE FROM " + table + ";";
            nrows=st.executeUpdate(del);
	    System.out.println("Delete operation has been done!");
        } catch (SQLException se) {
	    System.out.println("Fail to execute command");
            se.printStackTrace();
        }
    }
    // delete line from table
    public void delete (String table,String expmi,String expmr){
        int nrows=0;
        try {
            String del="DELETE FROM " + table + " WHERE exp_id=\'"+expmi+"\' and exp_run_nbr="+expmr+";";
            nrows=st.executeUpdate(del);
	    	System.out.println("Delete operation has been done!");
	    	JOptionPane.showMessageDialog(null,"Data from "+table+" were deleted successfully","End",JOptionPane.INFORMATION_MESSAGE);
        } catch (SQLException se) {
	    System.out.println("Fail to execute command");
        se.printStackTrace();
        }
    }
    // update query
    public void update (String sql)
    {
        int nrows=0;
        try {
            nrows=st2.executeUpdate(sql);
        } catch (SQLException se) {
	    System.out.println("Can't make update");
            se.printStackTrace();
        }
    }
    // select query
    public ResultSet select (String sql)
    {
	ResultSet result = null;
        try {
	    result = st.executeQuery(sql);
	} catch (SQLException se) {
            se.printStackTrace();
        }
	return result;
    }
    
 	public   void openbackup()
	{
		try{
    		String driverName = "org.gjt.mm.mysql.Driver";
    		Class.forName(driverName);
		    String url = "jdbc:mysql://localhost:3306/backup";//wlqetb//lqeec//porto
    		String username = "root";
    		String password = "aaaa";
    		dbc = DriverManager.getConnection(url, username, password); 	
        }
      catch (Exception e) {
      System.out.println("Failed: JDBC Driver Error: " + e.getMessage()); 
    	}
      try {
          stt=dbc.createStatement();
         }                            
      catch(SQLException se) {
	    System.out.println("nao criou setenca");
          se.printStackTrace();
      } 
	}
		public void closebackup()
		{
           	try{  
    		dbc.close();
    		}
    		catch(Exception e){
    		System.out.println("Could not stop connection");
    			}	
		}
    // insert data in experiment table of backup    
    public void insertExperiment2 (int row,String exp_id, String exp_run_nbr, String exp_date, String exp_time, 
            String exp_payload_size, String exp_tx_power, String exp_channel, String exp_topology, 
            String exp_node_type, String exp_country, String exp_city, String exp_description, String exp_nbr_nodes,
            String exp_inter_pkt_time, String exp_nbr_sent_packet, boolean exp_ackonOff, String exp_maxRetNbr, String traffic, String burstwin, String exp_place, String exp_implied_nodes){
			openbackup();
        		int nrows=0;
        		try {
            	String ins="INSERT INTO experiment (rownum, exp_id, exp_run_nbr, exp_date, exp_time, exp_payload_size, " +
                    "exp_inter_pkt_time, exp_nbr_sent_packet, exp_nbr_nodes, exp_tx_power, exp_channel, " +
                    "exp_ack_onoff, exp_max_retries, exp_topology, exp_node_type, exp_country, " +
                    "exp_city, exp_traffic, exp_description,exp_place,exp_implied_nodes, exp_burst_window) VALUES (" +
                    "'"+row+"', " +
                    "'"+exp_id+"', " +
                    "'"+exp_run_nbr+"', " +
                    "'"+exp_date+"', " + 
                    "'"+exp_time+"', " +
                    "'"+exp_payload_size+"', " +
                    "'"+exp_inter_pkt_time+"', " +
                    "'"+exp_nbr_sent_packet+"', " +
                    "'"+exp_nbr_nodes+"', " +
                    "'"+exp_tx_power+"', " +
                    "'"+exp_channel+"', " +
                    "'"+exp_ackonOff+"', " +
                    "'"+exp_maxRetNbr+"', " +
                    "'"+exp_topology+"', " +
                    "'"+exp_node_type+"', " +
                    "'"+exp_country+"', " +
                    "'"+exp_city+"', " +
                    "'"+traffic+"', " +
                    "'"+exp_description+"', " +
                    "'"+exp_place+"', " +
                    "'"+exp_implied_nodes+"', " +
                    "'"+burstwin+"');";
            		nrows=stt.executeUpdate(ins);
        			} catch (SQLException se) {
	    			System.out.println("Can't make update");
            		se.printStackTrace();
       				 }
 					closebackup();
		    }
		    Connection db=null;         
		    Statement st=null;          
		    Statement st2=null;         
		    Connection dbc=null;
		    Statement stt=null;  
    
}
