/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 
public class install{ 
  public static String PROGRAMCMDL1;
  public static String PROGRAMCMDW1;
void nodeprogram(int id, String comport)
{  
    try {
      Process p2 = null;
      System.out.println(">>OS is " + System.getProperty("os.name"));
      // distinguishing Operating system type
      if(System.getProperty("os.name").equals("Linux")) {
		comport = "bsl," + comport;
      	PROGRAMCMDL1 ="make telosb reinstall,"+id+" "+comport;
      	p2 = Runtime.getRuntime().exec(PROGRAMCMDL1); 
        p2.waitFor();
      }
      else{
      	// location of bash.exe application
      	// we will use the bash program to execute a bash script 
        PROGRAMCMDW1="c:\\tinyos\\cygwin\\bin\\bash.exe programNodes "+id+" "+comport;
    	p2 = Runtime.getRuntime().exec(PROGRAMCMDW1); 
        p2.waitFor();
        System.out.print("finish node"+id+" programming"); 
        	 }
    } 
    catch(Exception ex) { ex.printStackTrace(); } 
    	}
}
